SystemOrganization addCategory: #'Refactoring-Nautilus'!

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 5/20/2011 13:32'!
buildRenameRefactoringEngineFor: aClass

	| newName |
	newName := (UIManager default
			request: 'Enter the new class name:'
			initialAnswer: aClass name).
	newName isEmptyOrNil ifTrue: [ ^ nil ].
	^RenameClassRefactoring
		model: RBNamespace new
		rename: aClass
		to: newName! !

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 5/20/2011 13:12'!
doRename: oldName to: newName

	RefactoryChangeManager instance
		performChange: (RenameClassChange
			rename: oldName to: newName).! !

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 5/20/2011 19:02'!
performRefactoring: aRefactoring
	"Try to properly label aRefactoring and perform it or open the changes browser, depending on the preferences of the user."

	"self refactoringOptions: aRefactoring."
	"self label isNil ifFalse: [
		aRefactoring model name: (String streamContents: [ :stream |
			self cluster isNil
				ifFalse: [ stream nextPutAll: self cluster; nextPutAll: ', ' ].
			stream nextPutAll: self label ]) ]."

		self promptOnRefactoring
			ifFalse: [ aRefactoring execute ]
			ifTrue: [
				| browser |
				aRefactoring primitiveExecute.
				browser := ChangesBrowser change: aRefactoring changes.
				browser openInWorld ].
		"self refreshRefactoring: aRefactoring"! !

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 5/20/2011 13:40'!
promptOnRefactoring

	^ NautilusRefactoringExtension promptOnRefactoring! !

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 5/12/2011 18:06'!
refactoringClassMenu: aBuilder
	<nautilus2ClassMenu>
	
	(aBuilder item: #'Refactoring')
		order: 5000;
		enabledBlock: [ self selectedClasses size <= 1 and: [ self showInstance ]];
		withSeparatorAfter.! !

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 8/22/2011 14:01'!
refactoringClassSubmenu: aBuilder
	<nautilusClassMenu>
	
	(aBuilder item: #'Rename with RB')
		action: [self renameClassWithRefactoringEngine];
		parent: #Refactoring;
		order: 0.! !

!NautilusUI methodsFor: '*Refactoring-Nautilus' stamp: 'BenjaminVanRyseghem 5/20/2011 13:45'!
renameClassWithRefactoringEngine

	
	self selectedClass
		ifNotNil: [:aClass || refactoring | 
			refactoring := self buildRenameRefactoringEngineFor: aClass.
			refactoring ifNil: [ ^ self ].
			refactoring model environment: self browsedEnvironment.
			self performRefactoring: refactoring.
			[ [ [ self halt. self performRefactoring: refactoring ]
				on: RBRefactoringWarning
				do: [ :exception | self handleWarning: exception ] ]
				on: RBRefactoringError
				do: [ :exception | self handleError: exception ] ]
		
			"| oldName newName |
			oldName := aClass name.
			newName := UIManager default  request: 'Please type new class name' initialAnswer: oldName.
			newName isEmptyOrNil ifTrue: [ ^ self ].
			newName := newName asSymbol.
			newName = oldName ifTrue: [ ^ self ].
			(self class environment includesKey: newName)
				ifTrue: [ ^ self error: newName , ' already exists' ].
			self doRename: oldName to: newName ]"]! !

Object subclass: #ChangesBrowser
	instanceVariableNames: 'changes selectedIndex newVersions window builtVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Nautilus'!

!ChangesBrowser classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/20/2011 14:08'!
change: aChange

	^ self new
		changes: aChange;
		yourself! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/23/2011 12:12'!
accept

	self changes changes first executeNotifying: [].
	newVersions associations do: [:assoc || oldMethod newSource |
		" recompile modified methods "
		oldMethod := assoc key.
		newSource := assoc value.
		oldMethod actualClass compile: newSource classified: oldMethod category ].
	window delete! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
acceptAction

	^ self accept! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
acceptLabel

	^ 'Accept'! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:22'!
acceptState

	^ false! !

!ChangesBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/20/2011 18:50'!
addAll: aWindow

	aWindow
		addMorph: self buildChangesList 
		frame: (0@0 corner: 1@0.5).
	aWindow
		addMorph: self buildDiffTextArea 
		frame: (0@0.5 corner: 1@0.9).
	aWindow
		addMorph: (self buildButtonsRow:  aWindow)  
		frame: (0@0.9 corner: 1@1).! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 14:53'!
analyzeImpactOf: aChange 
	" I assume that here, aChange is only about a unique change "

	| change oldName|
	change := aChange changes first.
	oldName := change oldName.
	^ self retreiveUsersOf: oldName! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 16:35'!
buildAcceptButton

	^ (PluggableButtonMorph 
			on: self
			getState: #acceptState
			action: #acceptAction
			label: #acceptLabel)
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself! !

!ChangesBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/20/2011 18:54'!
buildButtonsRow: aWindow

	^ aWindow newRow: {
		self buildAcceptButton.
		self buildCancelButton}";
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		yourself"! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 16:35'!
buildCancelButton

	^ (PluggableButtonMorph 
			on: self
			getState: #cancelState
			action: #cancelAction
			label: #cancelLabel)
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 14:10'!
buildChangesList

	^ PluggableListMorph
			on: self
			list: #getChangesList
			selected: #selectedIndex
			changeSelected: #selectedIndex:
			menu: nil
			keystroke: nil! !

!ChangesBrowser methodsFor: 'text area behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:32'!
buildDiffFrom: aMethodReference

	| oldVersion newVersion |
	oldVersion := aMethodReference source.
	
	newVersions 
		at: aMethodReference
		ifPresent: [:string | ^ string].
		
	builtVersions at: aMethodReference
		ifPresent: [:string | newVersion := string ]
		ifAbsent: [ 
			newVersion := self constructNewVersionOf: aMethodReference index: (self selectedIndex).
			builtVersions at: aMethodReference put: newVersion.] .
	
	^ TextDiffBuilder 
		buildDisplayPatchFrom: oldVersion to: newVersion.! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 15:00'!
buildDiffTextArea

	^ PluggableTextMorph 
			on: self
			text: #getDiff
			accept: #setNewVersion:! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 18:54'!
cancel

	window delete! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
cancelAction

	^ self cancel! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
cancelLabel

	^ 'Cancel'! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:22'!
cancelState

	^ false! !

!ChangesBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/20/2011 14:08'!
changes

		^ changes! !

!ChangesBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/20/2011 14:08'!
changes: anObject
	
		changes := anObject! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 18:56'!
compileNewSource: aString for: aMethodReference

	| aClass |
	aClass := aMethodReference actualClass.
	aClass compile: aString classified: aMethodReference category! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 16:32'!
constructNewVersionOf: aMethodReference index: anInteger

	^ (self changes changes first changes at: (anInteger)) source! !

!ChangesBrowser methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 14:50'!
getChangesList

	^ self analyzeImpactOf: self changes! !

!ChangesBrowser methodsFor: 'text area behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 15:02'!
getDiff

	| selectedItem |
	selectedItem := self getChangesList at: self selectedIndex ifAbsent: [ ^ '' ].
	^ self buildDiffFrom: selectedItem! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 16:29'!
initialize

	super initialize.
	newVersions := Dictionary new.
	builtVersions := Dictionary new! !

!ChangesBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/20/2011 18:51'!
openInWorld 

	window := StandardWindow new 
				"model: self;
				yourself".
	self addAll: window.
	window openInWorld.
	window title: self title.
	^ window! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 19:00'!
retreiveUsersOf: aSymbol 

	| class |
	class := self class environment at: aSymbol ifAbsent: [ ^ {} ].
	^ class allCallsOnIn: self systemNavigation ! !

!ChangesBrowser methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 14:10'!
selectedIndex

	^ selectedIndex ifNil: [ selectedIndex := 0 ]! !

!ChangesBrowser methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 15:07'!
selectedIndex: anIndex

	selectedIndex := anIndex.
	self changed: #selectedIndex.
	self changed: #getDiff! !

!ChangesBrowser methodsFor: 'text area behavior' stamp: 'BenjaminVanRyseghem 5/23/2011 12:12'!
setNewVersion: aText
	
	| selectedItem |
	self changed: #clearUserEdits.
	selectedItem := self getChangesList at: self selectedIndex ifAbsent: [ ^ self ].
	newVersions at: selectedItem put: aText asString.! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 14:13'!
title

	^ 'Changes Browser'! !

Object subclass: #NautilusRefactoringExtension
	instanceVariableNames: ''
	classVariableNames: 'PromptOnRefactoring'
	poolDictionaries: ''
	category: 'Refactoring-Nautilus'!

!NautilusRefactoringExtension classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/20/2011 13:40'!
promptOnRefactoring

	^ PromptOnRefactoring ifNil: [ PromptOnRefactoring := true ]! !
